package com.unipi.talepis;


//Immutable class
//Can not be extended
public final class Student {
    //Private and final all fields
    private final String name;
    private final Integer age;
    private final Address address;

    //No setters

    public String getName() {
        return name;
    }

    public Integer getAge() {
        return age;
    }
    //Parameterized constructor with deep copy for mutable fields
    public Student(String name, Integer age, Address address) {
        this.name = name;
        this.age = age;
        Address tempAddress = new Address();
        //tempAddress.road = address.road;
        this.address = new Address();
        this.address.road = address.road;
        //this.address = tempAddress;
    }
    //Deep copy get for mutable field
    public Address getAddress() {
        Address tempAddress = new Address();
        tempAddress.road = this.address.road;
        return  tempAddress;
    }
}

class Address{
    String road;

    @Override
    public String toString() {
        return road;
    }
}
